using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace BedeCheese
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        Texture2D cheeseTexture;
        Rectangle cheeseRectangle;

        Texture2D breadTexture;
        Rectangle breadRectangle;

        Texture2D backgroundTexture;
        Rectangle backgroundRectangle;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            cheeseTexture = Content.Load<Texture2D>("Cheese");
            cheeseRectangle = new Rectangle(0, 0, 50, 50);


            breadTexture = Content.Load<Texture2D>("Bread");
            breadRectangle = new Rectangle(360, 560, 80, 20);

            backgroundTexture = Content.Load<Texture2D>("Background");
            backgroundRectangle = new Rectangle(0, 0, GraphicsDevice.Viewport.Width, GraphicsDevice.Viewport.Height);
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }
        int cheeseXSpeed = 3;
        int cheeseYSpeed = 3;

        int breadXSpeed = 4;

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // Move the bread
            GamePadState gamepad = GamePad.GetState(PlayerIndex.One);

            if (gamepad.DPad.Left == ButtonState.Pressed)
            {
                breadRectangle.X = breadRectangle.X - breadXSpeed;
            }
            if (gamepad.DPad.Right == ButtonState.Pressed)
            {
                breadRectangle.X = breadRectangle.X + breadXSpeed;
            }

            // Move the cheese
            cheeseRectangle.X = cheeseRectangle.X + cheeseXSpeed;

            if (cheeseRectangle.X < 0 ||
              cheeseRectangle.Right > GraphicsDevice.Viewport.Width)
            {
                cheeseXSpeed = cheeseXSpeed * -1;
            }

            cheeseRectangle.Y = cheeseRectangle.Y + cheeseYSpeed;

            if (cheeseRectangle.Y < 0 ||
              cheeseRectangle.Bottom > GraphicsDevice.Viewport.Height)
            {
                cheeseYSpeed = cheeseYSpeed * -1;
            }


            // Do the bounce off the bat

            if ( cheeseRectangle.Intersects(breadRectangle)) 
            {
                cheeseYSpeed = cheeseYSpeed * -1;
            }

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.WhiteSmoke);

            spriteBatch.Begin();

            // Draw the background slightly transparent so that the clear screen shows through
            // (find out more about the "alpha" channel to learn more about this
            spriteBatch.Draw(backgroundTexture, backgroundRectangle, new Color(255,255,255,120));

            // Draw the cheese
            spriteBatch.Draw(cheeseTexture, cheeseRectangle, Color.White);

            // Draw the bread
            spriteBatch.Draw(breadTexture, breadRectangle, Color.White);

            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
